puts "Running data capture script..."

puts "Connecting to the processor..."
	connect mb mdm

puts "Downloading the Microblaze program..."
	rst
	stop
	rst
	dow ADIEvalBoard.elf
	run
	stop

puts "Starting the data acquisition..."
	set startAcqAddr [mrd_var pStartAcquisition]
	set startAcqAddr [format "0x%08x" $startAcqAddr]
	mwr $startAcqAddr 1
	con
	after 1000
	stop

puts "Reading data from the system..."	
	set rxDataAddr [mrd_var pRxData]
	set rxDataAddr [format "0x%08x" $rxDataAddr]
	
	set conversionData {}
	set adcData [mrd $rxDataAddr 8192]
	for { set i 1 } { $i < 16384 } { incr i 2} {		
		set val [string trimleft [lindex $adcData $i] 0]
		if { ![string length $val] } {
			set val "0"
		}
		set val [expr 0x$val]
		lappend conversionData $val
		lappend conversionData "\n"
		set addr [expr $rxDataAddr + 4]
		set rxDataAddr [format "0x%08x" $addr]
    }

set final0 "Vin"
lappend final0 \n  
    
for {set i 0} {$i < [llength $conversionData]} {incr i 2} {
    set a [lindex $conversionData $i]
    set decimal [expr $a]
    if { $decimal > 32767 } {
    set decimal [expr $decimal - 65536]
    } 
    lappend final0 $decimal
    lappend final0 \n 
    }
    
puts "Ending the Microblaze program..."	
	mwr $startAcqAddr 0	
	con

puts "Moving data into file Acquisition.csv..."
    set fd [ open "Acquisition.csv" "a+" ]
    puts -nonewline $fd [ join $final0 ]
    close $fd

puts "Disconnecting from the processor..."
	stop
	#disconnect 0
	
puts "Data acquisition is complete. Data is stored in the file Acquisition.csv."

